﻿package 
{

	import Box2D.Collision.Shapes.b2CircleDef;
	import Box2D.Dynamics.Joints.b2DistanceJoint;
	import Box2D.Dynamics.Joints.b2DistanceJointDef;
    import flash.display.Sprite;
    import flash.events.*;

    import Box2D.Collision.b2AABB;
    import Box2D.Common.Math.b2Vec2;
    import Box2D.Dynamics.b2Body;
    import Box2D.Dynamics.b2BodyDef;
    import Box2D.Collision.Shapes.b2PolygonDef;
    import Box2D.Dynamics.Joints.b2RevoluteJoint;
    import Box2D.Dynamics.Joints.b2RevoluteJointDef;
    import Box2D.Dynamics.b2DebugDraw;
    import Box2D.Dynamics.b2World;
    
    // [SWF(backgroundColor="#444444", frameRate="24",width="500",height="500" )]

    /**
     * ...
     * @author takesho
     */
    public class Main extends Sprite 
    {
		
        //======================
        // Member data
        //======================
        public var m_world:b2World;
        public var m_iterations:int = 10;
        public var m_timeStep:Number = 1.0 / 24.0;
        public var m_physScale:Number = 100;		
		
		
				
		private var Body:b2Body;
		
		private var ancBody:b2Body;		
		
		
		private var jd:b2DistanceJointDef;
		
		private var currentAngle:Number;
		
        public function Main():void 
        {
			
			currentAngle = 0.6;
			initialization(currentAngle);
			
            stage.addEventListener(MouseEvent.MOUSE_WHEEL, onWheel);
            stage.addEventListener(MouseEvent.CLICK, onClick);
			
            addEventListener(Event.ENTER_FRAME, Update);

        }
		
		private function onWheel(event:MouseEvent):void {
			
			currentAngle -= event.delta / 512;
			if (currentAngle < 0)
				currentAngle = 0;
			initialization(currentAngle);
		}		
		
		private function onClick(event:MouseEvent):void {

			Body.ApplyForce(new b2Vec2(5, 0), new b2Vec2(0, 0));
		}		
		
		
        
        public function initialization(angle:Number):void
        {
			
			
			var tgtX:Number = 2 + 4 * Math.sin(angle);
			var tgtY:Number = 4.5 - 4 * Math.cos(angle);
			
            ///////////////////////////////////////////////////
            // world AABBの作成
            var worldAABB:b2AABB = new b2AABB();
            worldAABB.lowerBound.Set(-100.0, -100.0);
            worldAABB.upperBound.Set(100.0, 100.0);
            
            var gravity:b2Vec2 = new b2Vec2(0.0, 8.0);        // 重力ベクトルを定義する
            var doSleep:Boolean = false;                        // スリープ状態許可
            // worldオブジェクトの構築
            m_world = new b2World(worldAABB, gravity, doSleep);
            
			floorSet();

						
            
            /////////////////////////////////////////////////////
            ////// 静的物体
            /////////////////////////////////////////////////////
            // アンカー物体
            var ancBodyDef:b2BodyDef = new b2BodyDef();
            ancBodyDef.position.Set(2, 5.5);
			ancBodyDef.linearDamping = 1.0;
            ancBody = m_world.CreateBody(ancBodyDef);
            
            var ancShapeDef:b2PolygonDef = new b2PolygonDef();
			ancShapeDef.SetAsBox(0.8, 0.4);
			ancShapeDef.density = 1.0;
			ancShapeDef.restitution = 0;
			ancShapeDef.friction = 100;
            ancBody.CreateShape(ancShapeDef);
			ancBody.SetMassFromShapes();
            
            
            ///////////////////////////////////////////////////
            ////// 動的物体
            ///////////////////////////////////////////////////
            // 物体の作成
            var BodyDef:b2BodyDef = new b2BodyDef();
            BodyDef.position.Set(tgtX, tgtY);
            BodyDef.linearDamping = 1.0;
            Body = m_world.CreateBody(BodyDef);
            
            var ShapeDef:b2PolygonDef = new b2PolygonDef();
            ShapeDef.SetAsBox(0.2, 0.2);
            ShapeDef.density = 1;                // 密度
			ShapeDef.friction = 0;
            Body.CreateShape(ShapeDef);
            Body.SetMassFromShapes();
            
            
            ///////////////////////////////////////////////////
            ////// ジョイント
            ///////////////////////////////////////////////////
            // 回転ジョイント
			var rJointDef:b2RevoluteJointDef;
            rJointDef = new b2RevoluteJointDef();
            rJointDef.Initialize(Body, ancBody, ancBody.GetWorldCenter());            
            m_world.CreateJoint(rJointDef);			
			
			
            ///////////////////////////////////////////////////
            ////// 動的物体
            ///////////////////////////////////////////////////
            // 物体の作成
            var Body2:b2Body;
            var BodyDef2:b2BodyDef = new b2BodyDef();
            BodyDef2.position.Set(tgtX, tgtY + 1);
            BodyDef2.linearDamping = 1.0;
            Body2 = m_world.CreateBody(BodyDef2);
            
            var ShapeDef2:b2CircleDef = new b2CircleDef();
            ShapeDef2.radius = 0.3;
            ShapeDef2.density = 1;                // 密度
			ShapeDef2.friction = 0;
            Body2.CreateShape(ShapeDef2);
            Body2.SetMassFromShapes();
            
            
            ///////////////////////////////////////////////////
            ////// ジョイント
            ///////////////////////////////////////////////////
            // 回転ジョイント
            var rJointDef2:b2RevoluteJointDef = new b2RevoluteJointDef();
            rJointDef2.Initialize(Body, Body2, Body.GetWorldCenter());            
            m_world.CreateJoint(rJointDef2);
			

			createJoint();
			
            
            ///////////////////////////////////////////////////
            // 描画設定
            var debugDraw:b2DebugDraw = new b2DebugDraw();
            debugDraw.m_sprite = this;
            debugDraw.m_drawScale = m_physScale;        // 1mをxピクセルにする
            debugDraw.m_fillAlpha = 0.5;                // 不透明度
            debugDraw.m_lineThickness = 6;                // 線の太さ
            debugDraw.m_drawFlags = b2DebugDraw.e_shapeBit | b2DebugDraw.e_jointBit;
            m_world.SetDebugDraw(debugDraw);
	
        }
		
		
		private function createJoint():void {

			jd = new b2DistanceJointDef();
			jd.Initialize(ancBody, Body, new b2Vec2(1.3, 5.2), Body.GetPosition());
			m_world.CreateJoint(jd);
			
		}
        
        // シミュレーション
        public function Update(e:Event):void
        {
            if (m_world == null) {
                return;
            }
			
            m_world.Step(m_timeStep, m_iterations);    
        }
		
		
		private function floorSet():void {
			
			var floorBodyDef:b2BodyDef = new b2BodyDef();
			floorBodyDef.position.Set(4, 6);
			
			var floorShapeDef:b2PolygonDef = new b2PolygonDef();
			floorShapeDef.SetAsBox(4, 0.1);
			var floor:b2Body = m_world.CreateBody(floorBodyDef);
			floor.CreateShape(floorShapeDef);
			
			floorBodyDef = new b2BodyDef();
			floorBodyDef.position.Set(0, 3);
			
			floorShapeDef = new b2PolygonDef();
			floorShapeDef.SetAsBox(0.1, 3);
			
			floor = m_world.CreateBody(floorBodyDef);
			floor.CreateShape(floorShapeDef);
			
			floorBodyDef = new b2BodyDef();
			floorBodyDef.position.Set(8, 3);
			
			floorShapeDef = new b2PolygonDef();
			floorShapeDef.SetAsBox(0.1, 3);
			
			floor = m_world.CreateBody(floorBodyDef);
			floor.CreateShape(floorShapeDef);

			floorBodyDef = new b2BodyDef();
			floorBodyDef.position.Set(4, 0);
			
			floorShapeDef = new b2PolygonDef();
			floorShapeDef.SetAsBox(4, 0.1);
			
			floor = m_world.CreateBody(floorBodyDef);
			floor.CreateShape(floorShapeDef);
			
		}

        
    }
    
}
